@echo off
REM OH2BUA SWL KIT - Fall 2017 release.

cd C:\Osk
echo ======================== >> osk_dailylog.txt
echo Script start %TIME% >> osk_dailylog.txt

REM The things needed at very first run at midnight.
time /t | grep -q 00.00 || goto NOTFIRSTRUN
date /t >> osk_dailylog.txt
echo First run %TIME% >> osk_dailylog.txt
REM End disturbing applications.
taskkill /IM HDSDR.exe /IM SDRuno.exe /IM wsjtx.exe /IM jt9.exe /F /T
timeout /T 1
rm -rf %TEMP%\WSJT*
REM Clear the logs.
cat nul > "C:\Users\OH2BUA\AppData\Local\WSJT-X - SDR160\ALL.TXT"
cat nul > osk_5m_now.txt
REM Optional: Reset to good HDSDR regedit settings (you must have them exported to hdsdrplay.reg).
REM Optional: regedit /S hdsdrplay.reg
start "" "C:\Program Files (x86)\wsjtx\bin\wsjtx.exe" --rig-name=SDR160
start "" "C:\Program Files (x86)\HDSDR\HDSDR.exe" -profile MWREC -as
echo Done first run matters >> osk_dailylog.txt
:NOTFIRSTRUN

REM Parse WSJT-X log to see if DX happens.
echo Start log parse %TIME% >> osk_dailylog.txt
cat osk_5m_now.txt > osk_5m_was.txt
cat "C:\Users\OH2BUA\AppData\Local\WSJT-X - SDR160\ALL.TXT" | sed "s/$/\r/" >> osk_ftall.txt
grep -f osk_squares.txt "C:\Users\OH2BUA\AppData\Local\WSJT-X - SDR160\ALL.TXT" | sed "s/$/\r/" > osk_5m_now.txt
cat osk_5m_now.txt >> osk_ftdxall.txt
cat nul > "C:\Users\OH2BUA\AppData\Local\WSJT-X - SDR160\ALL.TXT"
grep -q ..... osk_5m_now.txt && cat osk_5m_now.txt >> osk_dailylog.txt
echo End log parse >> osk_dailylog.txt

REM Switch from LISTEN to RECORD if DX heard, and time is less than 11 hours.
grep -q ..... osk_5m_was.txt || ( time /t | grep -q 11. || grep -q ..... osk_5m_now.txt && taskkill /IM HDSDR.exe /F /T && echo Listen to Record switch %TIME% >> osk_dailylog.txt && start "" "C:\Program Files (x86)\HDSDR\HDSDR.exe" -profile MWREC -as -recRF )
echo End LIStoREC check >> osk_dailylog.txt

REM Switch from RECORD to LISTEN if DX disappeared.
grep -q ..... osk_5m_was.txt && ( grep -q ..... osk_5m_now.txt || taskkill /IM HDSDR.exe /F /T && echo Record to Listen switch %TIME% >> osk_dailylog.txt && timeout /T 1 && start "" "C:\Program Files (x86)\HDSDR\HDSDR.exe" -profile MWREC -as ) 
echo End RECtoLIS check >> osk_dailylog.txt

REM At 11:55, end the whole thing.
time /t | grep -q 11.55 || goto NOTLASTRUN
taskkill /IM HDSDR.exe /F /T
echo Last run %TIME% >> osk_dailylog.txt
:NOTLASTRUN
echo End lastrun check >> osk_dailylog.txt

echo Script end %TIME% >> osk_dailylog.txt